:: ==================================================================================
:: NAME:	Reset Windows Update Tool.
:: DESCRIPTION:	This script reset the Windows Update Components.
:: AUTHOR:	Manuel Gil.
:: VERSION:	10.5.3.7
:: WEBSITE:	http://wureset.com
:: ==================================================================================


:: Set console.
:: void mode();
:: /************************************************************************************/
:mode
	echo off
	title Reset Windows Update Tool.
	mode con cols=80 lines=34

	cls

	goto getValues
goto :eof
:: /************************************************************************************/


:: Print Top Text.
::		@param - text = the text to print (%*).
:: void print(string text);
:: /*************************************************************************************/
:print
	cls
	echo.
	echo.%name% [Version: %version%]
	echo.Reset Windows Update Tool.
	echo.
	echo.%*
	echo.
goto :eof
:: /*************************************************************************************/


:: Add Value in the Registry.
::		@param - key = the key or entry to be added (%~1).
::				value = the value to be added under the selected key (%~2).
::				type = the type for the registry entry (%~3).
::				data = the data for the new registry entry (%~4).
:: void addReg(string key, string value, string type, string data);
:: /*************************************************************************************/
:addReg
	reg add "%~1" /v "%~2" /t "%~3" /d "%~4" /f
goto :eof
:: /*************************************************************************************/


:: Load the system values.
:: void getValues();
:: /************************************************************************************/
:getValues
	for /f "tokens=4-5 delims=[] " %%a in ('ver') do set version=%%a%%b
	for %%a in (%version%) do set version=%%a

	if %version% EQU 5.1.2600 (
		:: Name: "Microsoft Windows XP"
		set name=Microsoft Windows XP
		:: Family: Windows 5
		set family=5
		:: Compatibility: Yes
		set allow=Yes
	) else if %version% EQU 5.2.3790 (
		:: Name: "Microsoft Windows XP Professional x64 Edition"
		set name=Microsoft Windows XP Professional x64 Edition
		:: Family: Windows 5
		set family=5
		:: Compatibility: Yes
		set allow=Yes
	) else if %version% EQU 6.0.6000 (
		:: Name: "Microsoft Windows Vista"
		set name=Microsoft Windows Vista
		:: Family: Windows 6
		set family=6
		:: Compatibility: Yes
		set allow=Yes
	) else if %version% EQU 6.0.6001 (
		:: Name: "Microsoft Windows Vista SP1"
		set name=Microsoft Windows Vista SP1
		:: Family: Windows 6
		set family=6
		:: Compatibility: Yes
		set allow=Yes
	) else if %version% EQU 6.0.6002 (
		:: Name: "Microsoft Windows Vista SP2"
		set name=Microsoft Windows Vista SP2
		:: Family: Windows 6
		set family=6
		:: Compatibility: Yes
		set allow=Yes
	) else if %version% EQU 6.1.7600 (
		:: Name: "Microsoft Windows 7"
		set name=Microsoft Windows 7
		:: Family: Windows 7
		set family=7
		:: Compatibility: Yes
		set allow=Yes
	) else if %version% EQU 6.1.7601 (
		:: Name: "Microsoft Windows 7 SP1"
		set name=Microsoft Windows 7 SP1
		:: Family: Windows 7
		set family=7
		:: Compatibility: Yes
		set allow=Yes
	) else if %version% EQU 6.2.9200 (
		:: Name: "Microsoft Windows 8"
		set name=Microsoft Windows 8
		:: Family: Windows 8
		set family=8
		:: Compatibility: Yes
		set allow=Yes
	) else if %version% EQU 6.3.9200 (
		:: Name: "Microsoft Windows 8.1"
		set name=Microsoft Windows 8.1
		:: Family: Windows 8
		set family=8
		:: Compatibility: Yes
		set allow=Yes
	) else if %version% EQU 6.3.9600 (
		:: Name: "Microsoft Windows 8.1 Update 1"
		set name=Microsoft Windows 8.1 Update 1
		:: Family: Windows 8
		set family=8
		:: Compatibility: Yes
		set allow=Yes
	) else (
		ver | find "10.0." > nul
		if %errorlevel% EQU 0 (
			:: Name: "Microsoft Windows 10"
			set name=Microsoft Windows 10
			:: Family: Windows 10
			set family=10
			:: Compatibility: Yes
			set allow=Yes
		) else (
			:: Name: "Unknown"
			set name=Unknown
			:: Compatibility: No
			set allow=No
		)
	)

	call :print %name% detected . . .

	if %allow% EQU Yes goto permission

	call :print Desole, ce systeme d'exploitation n'est pas compatible avec cet outil

	echo.    Une erreur s'est produite lors de la tentative de verification de votre systeme
	echo.    Vous utilisez peut-etre une version commerciale ou de test
	echo.
	echo.    sinon, verifiez que votre systeme dispose du correctif de securite approprie.
				   
	echo.

	echo.Appuyez sur n'importe quelle touche pour continuer...
	pause>nul
goto :eof
:: /************************************************************************************/


:: Checking for Administrator elevation.
:: void permission();
:: /************************************************************************************/
:permission
	openfiles>nul 2>&1

	if %errorlevel% EQU 0 goto terms

	call :print Verification de l'elevation de l'administrateur

	echo.    Vous n'avez pas executer l'outil en mode administrateur
	echo.    Cet outil ne peut pas faire son travail sans elevation.
	echo.
	echo.    Vous devez executer cet outil en tant qu'administrateur.
	echo.

	echo. Appuyez sur n'importe quelle touche pour continuer...
	pause>nul
goto :eof
:: /************************************************************************************/


:: Terms.
:: void terms();
:: /*************************************************************************************/
:terms
	call :print Termes et conditions d'utilisation

	echo. Les methodes a l'interieur de cet outil modifient les 
	echo. fichiers et les parametres de registre.
	echo. Pendant que vous etes teste et avez tendance a travailler,
	echo. nous n'assumons aucune responsabilite
	echo. l'utilisation de cet outil.
	echo.
	echo. Cet outil est fourni sans garantie. Tout dommage cause est votre
	echo. propre responsabilite.
	echo.
	echo. De plus, les fichiers de commandes sont presque toujours signales 
	echo. par un antivirus, n'hesitez pas pour revoir le code en cas de doute.
	echo.

	choice /c YN /n /m "Voulez-vous continuer ce processus ? (Y/N) "
	if %errorlevel% EQU 1 (
		goto menu
	) else if %errorlevel% EQU 2 (
		goto close
	) else if %errorlevel% EQU 9009 (
		echo.
		echo.Une erreur imprevue s'est produite
		echo.
		echo.Appuyez sur n'importe quelle touche pour continuer...
		pause>nul
		goto menu
	)
goto :eof
:: /*************************************************************************************/


:: Menu of tool.
:: void menu();
:: /*************************************************************************************/
:menu
	call :print Cet outil reinitialise les composants de Windows Update

	echo.	1. Ouvrir la protection du systeme
	echo.	2. Reinitialiser les composants Windows Update
	echo.	3. Supprimer des fichiers temporaires dans Windows
	echo.	4. Ouvrir les options de l'explorateur Internet
	echo.	5. Scanner tous les fichiers systeme proteges (CHKDSK)
	echo.	6. Scanner l'image pour verifier la corruption (SFC)
	echo.	7. Verifier les corruptions detectees (DISM)
	echo.	8. Verifie si l'image a ete signalee comme corrompue (DISM)
	echo.	9. Effectue automatiquement les operations de reparation (DISM)
	echo.	10. Nettoyer les composants remplaces (DISM)
	echo.	11. Supprime toutes les valeurs de registre incorrectes
	echo.	12. Reparations / reinitialisation des parametres Winsock
	echo.	13. Mise a jour de la strategie de groupe des forces
	echo.	14. Recherche les mises a jour Windows
	echo.	15. Execute SetupDiag (necessite .NET Framework 4.6)
	echo.	16. Explore d'autres solutions locales
	echo.	17. Explore d'autres solutions en ligne
	echo.	18. Telecharge les outils de diagnostic
	echo.	19. Redemarrer votre PC
	echo.
	echo.                                            ?. Aide.    0. Fermer.
	echo.

	set /p option=Selectionner une option : 

	if %option% EQU 0 (
		goto close
	) else if %option% EQU 1 (
		call :sysProtection
	) else if %option% EQU 2 (
		call :components
	) else if %option% EQU 3 (
		call :temp
	) else if %option% EQU 4 (
		call :iOptions
	) else if %option% EQU 5 (
		call :chkdsk
	) else if %option% EQU 6 (
		call :sfc
	) else if %option% EQU 7 (
		call :dism1
	) else if %option% EQU 8 (
		call :dism2
	) else if %option% EQU 9 (
		call :dism3
	) else if %option% EQU 10 (
		call :dism4
	) else if %option% EQU 11 (
		call :regedit
	) else if %option% EQU 12 (
		call :winsock
	) else if %option% EQU 13 (
		call :gpupdate
	) else if %option% EQU 14 (
		call :updates
	) else if %option% EQU 15 (
		call :setupDiag
	) else if %option% EQU 16 (
		call :local
	) else if %option% EQU 17 (
		call :online
	) else if %option% EQU 18 (
		call :diagnostic
	) else if %option% EQU 19 (
		call :restart
	) else if %option% EQU ? (
		call :help
	) else (
		echo.
		echo.Option invalide
		echo.
		echo.Appuyez sur n'importe quelle touche pour continuer...
		pause>nul
	)
	
	goto menu
goto :eof	
:: /*************************************************************************************/


:: Open system protection.
:: void sysProtection();
:: /*************************************************************************************/
:sysProtection
	call :print Ouverture de la protection du systeme

	if %family% NEQ 5 (
		start systempropertiesprotection
	) else (
		echo.
		echo.Desole, cette option n'est pas disponible sur ce systeme d'exploitation
		echo.
		echo.Appuyez sur n'importe quelle touche pour continuer...
		pause>nul
	)
goto :eof
:: /*************************************************************************************/


:: Run the reset Windows Update components.
:: void components();
:: /*************************************************************************************/
:components
	:: ----- Stopping the Windows Update services -----
	call :print Arret des services Windows Update
	net stop bits

	call :print Arret des services Windows Update
	net stop wuauserv

	call :print Arret des services Windows Update
	net stop appidsvc

	call :print Arret des services Windows Update
	net stop cryptsvc

	call :print Annulation du processus Windows Update
	taskkill /im wuauclt.exe /f

	:: ----- Checking the services status -----
	call :print Verification de l'etat des services

	sc query bits | findstr /I /C:"STOPPED"
	if %errorlevel% NEQ 0 (
		echo.    Echec de l'arret du service BITS
		echo.
		echo.Appuyez sur n'importe quelle touche pour continuer...
		pause>nul
		goto :eof
	)

	call :print Verification de l'etat des services

	sc query wuauserv | findstr /I /C:"STOPPED"
	if %errorlevel% NEQ 0 (
		echo.    Impossible d'arreter le service Windows Update
		echo.
		echo.Appuyez sur n'importe quelle touche pour continuer...
		pause>nul
		goto :eof
	)

	call :print Verification de l'etat des services

	sc query appidsvc | findstr /I /C:"STOPPED"
	if %errorlevel% NEQ 0 (
		sc query appidsvc | findstr /I /C:"OpenService FAILED 1060"
		if %errorlevel% NEQ 0 (
			echo.    Echec de l'arret du service d'identite d'application.
			echo.
			echo.Appuyez sur n'importe quelle touche pour continuer...
			pause>nul
			if %family% NEQ 6 goto :eof
		)
	)

	call :print Verification de l'etat des services

	sc query cryptsvc | findstr /I /C:"STOPPED"
	if %errorlevel% NEQ 0 (
		echo.    Echec de l'arret du service des services cryptographiques
		echo.
		echo.Appuyez sur n'importe quelle touche pour continuer...
		pause>nul
		goto :eof
	)

	:: ----- Delete the qmgr*.dat files -----
	call :print Suppression des fichiers qmgr*.dat

	del /s /q /f "%ALLUSERSPROFILE%\Application Data\Microsoft\Network\Downloader\qmgr*.dat"
	del /s /q /f "%ALLUSERSPROFILE%\Microsoft\Network\Downloader\qmgr*.dat"

	:: ----- Renaming the softare distribution folders backup copies -----
	call :print Suppression des anciennes copies de sauvegarde de la distribution de logiciels

	cd /d %SYSTEMROOT%

	if exist "%SYSTEMROOT%\winsxs\pending.xml.bak" (
		del /s /q /f "%SYSTEMROOT%\winsxs\pending.xml.bak"
	)
	if exist "%SYSTEMROOT%\SoftwareDistribution.bak" (
		rmdir /s /q "%SYSTEMROOT%\SoftwareDistribution.bak"
	)
	if exist "%SYSTEMROOT%\system32\Catroot2.bak" (
		rmdir /s /q "%SYSTEMROOT%\system32\Catroot2.bak"
	)
	if exist "%SYSTEMROOT%\WindowsUpdate.log.bak" (
		del /s /q /f "%SYSTEMROOT%\WindowsUpdate.log.bak"
	)

	call :print Renommer les dossiers de distribution de logiciels

	if exist "%SYSTEMROOT%\winsxs\pending.xml" (
		takeown /f "%SYSTEMROOT%\winsxs\pending.xml"
		attrib -r -s -h /s /d "%SYSTEMROOT%\winsxs\pending.xml"
		ren "%SYSTEMROOT%\winsxs\pending.xml" pending.xml.bak
	)
	if exist "%SYSTEMROOT%\SoftwareDistribution" (
		attrib -r -s -h /s /d "%SYSTEMROOT%\SoftwareDistribution"
		ren "%SYSTEMROOT%\SoftwareDistribution" SoftwareDistribution.bak
		if exist "%SYSTEMROOT%\SoftwareDistribution" (
			echo.
			echo.    Impossible de renommer le dossier SoftwareDistribution
			echo.
			echo.Appuyez sur n'importe quelle touche pour continuer...
			pause>nul
			goto :eof
		)
	)
	if exist "%SYSTEMROOT%\system32\Catroot2" (
		attrib -r -s -h /s /d "%SYSTEMROOT%\system32\Catroot2"
		ren "%SYSTEMROOT%\system32\Catroot2" Catroot2.bak
	)
	if exist "%SYSTEMROOT%\WindowsUpdate.log" (
		attrib -r -s -h /s /d "%SYSTEMROOT%\WindowsUpdate.log"
		ren "%SYSTEMROOT%\WindowsUpdate.log" WindowsUpdate.log.bak
	)

	:: ----- Reset the BITS service and the Windows Update service to the default security descriptor -----
	call :print Reinitialisez le service BITS et le service Windows Update sur le descripteur de securite par défaut.

	sc.exe sdset wuauserv D:(A;CI;CCLCSWRPLORC;;;AU)(A;;CCDCLCSWRPWPDTLOCRSDRCWDWO;;;BA)(A;;CCDCLCSWRPWPDTLOCRSDRCWDWO;;;SY)S:(AU;FA;CCDCLCSWRPWPDTLOSDRCWDWO;;;WD)
	sc.exe sdset bits D:(A;CI;CCDCLCSWRPWPDTLOCRSDRCWDWO;;;SY)(A;;CCDCLCSWRPWPDTLOCRSDRCWDWO;;;BA)(A;;CCLCSWLOCRRC;;;IU)(A;;CCLCSWLOCRRC;;;SU)S:(AU;SAFA;WDWO;;;BA)
	sc.exe sdset cryptsvc D:(A;;CCLCSWRPWPDTLOCRRC;;;SY)(A;;CCDCLCSWRPWPDTLOCRSDRCWDWO;;;BA)(A;;CCLCSWLOCRRC;;;IU)(A;;CCLCSWLOCRRC;;;SU)(A;;CCLCSWRPWPDTLOCRRC;;;SO)(A;;CCLCSWLORC;;;AC)(A;;CCLCSWLORC;;;S-1-15-3-1024-3203351429-2120443784-2872670797-1918958302-2829055647-4275794519-765664414-2751773334)
	sc.exe sdset trustedinstaller D:(A;CI;CCDCLCSWRPWPDTLOCRSDRCWDWO;;;SY)(A;;CCDCLCSWRPWPDTLOCRRC;;;BA)(A;;CCLCSWLOCRRC;;;IU)(A;;CCLCSWLOCRRC;;;SU)S:(AU;SAFA;WDWO;;;BA)

	:: ----- Reregister the BITS files and the Windows Update files -----
	call :print Reenregistrez les fichiers BITS et les fichiers Windows Update

	cd /d %SYSTEMROOT%\system32
	regsvr32.exe /s atl.dll
	regsvr32.exe /s urlmon.dll
	regsvr32.exe /s mshtml.dll
	regsvr32.exe /s shdocvw.dll
	regsvr32.exe /s browseui.dll
	regsvr32.exe /s jscript.dll
	regsvr32.exe /s vbscript.dll
	regsvr32.exe /s scrrun.dll
	regsvr32.exe /s msxml.dll
	regsvr32.exe /s msxml3.dll
	regsvr32.exe /s msxml6.dll
	regsvr32.exe /s actxprxy.dll
	regsvr32.exe /s softpub.dll
	regsvr32.exe /s wintrust.dll
	regsvr32.exe /s dssenh.dll
	regsvr32.exe /s rsaenh.dll
	regsvr32.exe /s gpkcsp.dll
	regsvr32.exe /s sccbase.dll
	regsvr32.exe /s slbcsp.dll
	regsvr32.exe /s cryptdlg.dll
	regsvr32.exe /s oleaut32.dll
	regsvr32.exe /s ole32.dll
	regsvr32.exe /s shell32.dll
	regsvr32.exe /s initpki.dll
	regsvr32.exe /s wuapi.dll
	regsvr32.exe /s wuaueng.dll
	regsvr32.exe /s wuaueng1.dll
	regsvr32.exe /s wucltui.dll
	regsvr32.exe /s wups.dll
	regsvr32.exe /s wups2.dll
	regsvr32.exe /s wuweb.dll
	regsvr32.exe /s qmgr.dll
	regsvr32.exe /s qmgrprxy.dll
	regsvr32.exe /s wucltux.dll
	regsvr32.exe /s muweb.dll
	regsvr32.exe /s wuwebv.dll

	:: ----- Resetting Winsock -----
	call :print Reinitialisation de Winsock
	netsh winsock reset

	:: ----- Resetting WinHTTP Proxy -----
	call :print Reinitialisation du proxy WinHTTP

	if %family% EQU 5 (
		proxycfg.exe -d
	) else (
		netsh winhttp reset proxy
	)

	:: ----- Set the startup type as automatic -----
	call :print Reinitialisation des services en automatique
	sc.exe config wuauserv start= auto
	sc.exe config bits start= delayed-auto
	sc.exe config cryptsvc start= auto
	sc.exe config TrustedInstaller start= demand
	sc.exe config DcomLaunch start= auto

	:: ----- Starting the Windows Update services -----
	call :print Demarrage des services Windows Update
	net start bits

	call :print Demarrage des services Windows Update
	net start wuauserv

	call :print Demarrage des services Windows Update
	net start appidsvc

	call :print Demarrage des services Windows Update
	net start cryptsvc

	call :print Demarrage des services Windows Update
	net start DcomLaunch

	:: ----- End process -----
	call :print L'operation s'est deroulee avec succes

	echo.Appuyez sur n'importe quelle touche pour continuer...
	pause>nul
goto :eof
:: /*************************************************************************************/


:: Delete temporary files in Windows.
:: void temp();
:: /*************************************************************************************/
:temp
	call :print Suppression des fichiers temporaires dans Windows

	del /s /f /q "%TEMP%\*.*"
	del /s /f /q "%SYSTEMROOT%\Temp\*.*"

	echo.
	echo.Appuyez sur n'importe quelle touche pour continuer...
	pause>nul
goto :eof
:: /*************************************************************************************/


:: Open the Internet Explorer options.
:: void iOptions();
:: /*************************************************************************************/
:iOptions
	call :print Ouverture des options d'Internet Explorer

	start InetCpl.cpl
goto :eof
:: /*************************************************************************************/


:: Check and repair errors on the disk.
:: void chkdsk();
:: /*************************************************************************************/
:chkdsk
	call :print Verifier le systeme de fichiers et les metadonnees du systeme de fichiers d'un volume pour les erreurs logiques et physiques (CHKDSK)

	chkdsk %SYSTEMDRIVE% /f /r

	if %errorlevel% EQU 0 (
		echo.
		echo.L'operation s'est deroulee avec succes
	) else (
		echo.
		echo.Une erreur s'est produite pendant le fonctionnement
	)

	echo.
	echo.Appuyez sur n'importe quelle touche pour continuer...
	pause>nul
goto :eof
:: /*************************************************************************************/


:: Scans all protected system files.
:: void sfc();
:: /*************************************************************************************/
:sfc
	call :print Analysez vos fichiers systeme et reparez les fichiers système manquants ou corrompus (SFC)

	if %family% NEQ 5 (
		sfc /scannow
	) else (
		echo.Desole, cette option n'est pas disponible sur ce systeme d'exploitation
	)

	if %errorlevel% EQU 0 (
		echo.
		echo.L'operation s'est deroulee avec succes
	) else (
		echo.
		echo.Une erreur s'est produite pendant le fonctionnement
	)

	echo.
	echo.Appuyez sur n'importe quelle touche pour continuer...
	pause>nul
goto :eof
:: /*************************************************************************************/


:: Scan the image to check for corruption.
:: void dism1();
:: /*************************************************************************************/
:dism1
	call :print Analysez l'image pour detecter la corruption du magasin de composants (DISM/ScanHealth).

	if %family% EQU 8 (
		Dism.exe /Online /Cleanup-Image /ScanHealth
	) else if %family% EQU 10 (
		Dism.exe /Online /Cleanup-Image /ScanHealth
	) else (
		echo.Desole, cette option n'est pas disponible sur ce systeme d'exploitation.

	)

	if %errorlevel% EQU 0 (
		echo.
		echo.L'operation s'est deroulee avec succes
	) else (
		echo.
		echo.
	)

	echo.
	echo.Appuyez sur n'importe quelle touche pour continuer...
	pause>nul
goto :eof
:: /*************************************************************************************/


:: Check the detected corruptions.
:: void dism2();
:: /*************************************************************************************/
:dism2
	call :print Verifiez si l'image a ete marquee comme corrompue par un processus ayant echoue et si la corruption peut etre reparee ( DISM/CheckHealth).

	if %family% EQU 8 (
		Dism.exe /Online /Cleanup-Image /CheckHealth
	) else if %family% EQU 10 (
		Dism.exe /Online /Cleanup-Image /CheckHealth
	) else (
		echo.Desole, cette option n'est pas disponible sur ce systeme d'exploitation
	)

	if %errorlevel% EQU 0 (
		echo.
		echo.L'operation s'est deroulee avec succes
	) else (
		echo.
		echo.Une erreur s'est produite pendant le fonctionnement
	)

	echo.
	echo.Appuyez sur n'importe quelle touche pour continuer...
	pause>nul
goto :eof
:: /*************************************************************************************/


:: Repair the Windows image.
:: void dism3();
:: /*************************************************************************************/
:dism3
	call :print Analysez l'image pour detecter la corruption du magasin de composants, puis effectuez automatiquement les operations de reparation (DISM/RestoreHealth)

	if %family% EQU 8 (
		Dism.exe /Online /Cleanup-Image /RestoreHealth
	) else if %family% EQU 10 (
		Dism.exe /Online /Cleanup-Image /RestoreHealth
	) else (
		echo.Desole, cette option n'est pas disponible sur ce systeme d'exploitation
	)

	if %errorlevel% EQU 0 (
		echo.
		echo.L'operation s'est deroulee avec succes
	) else (
		echo.
		echo.Une erreur s'est produite pendant le fonctionnement
	)

	echo.
	echo.Appuyez sur n'importe quelle touche pour continuer...
	pause>nul
goto :eof
:: /*************************************************************************************/


:: Clean up the superseded components.
:: void dism4();
:: /*************************************************************************************/
:dism4
	call :print Nettoyez les composants remplaces et reduisez la taille du magasin de composants (DISM/StartComponentCleanup)

	if %family% EQU 8 (
		Dism.exe /Online /Cleanup-Image /StartComponentCleanup
	) else if %family% EQU 10 (
		Dism.exe /Online /Cleanup-Image /StartComponentCleanup
	) else (
		echo.Desole, cette option n'est pas disponible sur ce systeme d'exploitation
	)

	if %errorlevel% EQU 0 (
		echo.
		echo.L'operation s'est deroulee avec succes
	) else (
		echo.
		echo.Une erreur s'est produite pendant le fonctionnement
	)

	echo.
	echo.Appuyez sur n'importe quelle touche pour continuer...
	pause>nul
goto :eof
:: /*************************************************************************************/


:: Change invalid values.
:: void regedit();
:: /*************************************************************************************/
:regedit
	for /f "tokens=1-5 delims=/., " %%a in ("%date%") do (
		set now=%%a%%b%%c%%d%time:~0,2%%time:~3,2%
	)

	if not exist "%USERPROFILE%\Desktop\Backup\Regedit\%now%\" (
		mkdir "%USERPROFILE%\Desktop\Backup\Regedit\%now%\"
	)

	:: ----- Create a backup of the Registry -----
	call :print Making a backup of the Registry in: %USERPROFILE%\Desktop\Backup\Regedit\%now%\

	if exist "%USERPROFILE%\Desktop\Backup\Regedit\%now%\HKLM.reg" (
		echo.An unexpected error has occurred.
		echo.
		echo.    Changes were not carried out in the registry.
		echo.    Will try it later.
		echo.
		echo.Appuyez sur n'importe quelle touche pour continuer...
		pause>nul
		goto :eof
	) else (
		reg Export HKCR "%USERPROFILE%\Desktop\Backup\Regedit\%now%\HKCR.reg"
		reg Export HKCU "%USERPROFILE%\Desktop\Backup\Regedit\%now%\HKCU.reg"
		reg Export HKLM "%USERPROFILE%\Desktop\Backup\Regedit\%now%\HKLM.reg"
		reg Export HKU "%USERPROFILE%\Desktop\Backup\Regedit\%now%\HKU.reg"
		reg Export HKCC "%USERPROFILE%\Desktop\Backup\Regedit\%now%\HKCC.reg"
	)

	:: ----- Checking backup -----
	call :print Checking the backup.

	if not exist "%USERPROFILE%\Desktop\Backup\Regedit\%now%\HKLM.reg" (
		echo.An unexpected error has occurred.
		echo.
		echo.    Something went wrong.
		echo.    Voulez-vous creez manuellement une sauvegarde du registre avant de continuer
		echo.
		echo.Appuyez sur n'importe quelle touche pour continuer...
		pause>nul
	) else (
		echo.L'operation s'est deroulee avec succes
		echo.
	)

	:: ----- Delete keys in the Registry -----
	call :print Suppression de valeurs dans le registre

	reg delete "HKCU\Software\Microsoft\Windows\CurrentVersion\AdvertisingInfo" /f
	reg delete "HKCU\Software\Microsoft\Windows\CurrentVersion\Policies\WindowsUpdate" /f
	reg delete "HKCU\Software\Microsoft\WindowsSelfHost" /f
	reg delete "HKLM\Software\Microsoft\Windows\CurrentVersion\WindowsStore\WindowsUpdate" /f
	reg delete "HKLM\Software\Microsoft\Windows\CurrentVersion\WindowsUpdate" /f
	reg delete "HKLM\Software\Microsoft\WindowsSelfHost" /f
	reg delete "HKLM\Software\WOW6432Node\Microsoft\Windows\CurrentVersion\WindowsStore\WindowsUpdate" /f

	reg delete "HKLM\COMPONENTS\PendingXmlIdentifier" /f
	reg delete "HKLM\COMPONENTS\NextQueueEntryIndex" /f
	reg delete "HKLM\COMPONENTS\AdvancedInstallersNeedResolving" /f
	reg delete "HKLM\SOFTWARE\Policies\Microsoft\Windows\WindowsUpdate" /f
	
	reg delete "HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\WindowsUpdate" /v ResetClient /f
	reg delete "HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\WindowsUpdate" /v ResetDataStoreReason /f

	reg delete "HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\WindowsUpdate" /v PingID /f
	reg delete "HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\WindowsUpdate" /v AccountDomainSid /f
	reg delete "HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\WindowsUpdate" /v SusClientId /f
	reg delete "HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\WindowsUpdate" /v SusClientIDValidation /f

	reg delete "HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\WindowsUpdate\Auto Update" /v AUState /f

	reg delete "HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\WindowsUpdate\Auto Update" /v LastWaitTimeout /f
	reg delete "HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\WindowsUpdate\Auto Update" /v DetectionstartTime /f
	reg delete "HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\WindowsUpdate\Auto Update" /v NextDetectionTime /f

	reg delete "HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\WindowsUpdate\Auto Update\RebootRequired" /f

	reg delete "HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\WindowsUpdate\Auto Update\Results" /f

	reg delete "HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\WindowsUpdate\Reporting" /v SamplingValue /f
	reg delete "HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\WindowsUpdate\Services" /v ReregisterAuthorizationCab /f

	:: ----- Add keys in the Registry -----
	call :print Adding values in the Registry.

	set key=HKLM\SOFTWARE\Microsoft\WindowsUpdate\UX
	call :addReg "%key%" "IsConvergedUpdateStackEnabled" "REG_DWORD" "0"

	set key=HKLM\SOFTWARE\Microsoft\WindowsUpdate\UX\Settings
	call :addReg "%key%" "UxOption" "REG_DWORD" "0"

	set key=HKCU\Software\Microsoft\Windows\CurrentVersion\Explorer\User Shell Folders
	call :addReg "%key%" "AppData" "REG_EXPAND_SZ" "%USERPROFILE%\AppData\Roaming"

	set key=HKLM\Software\Microsoft\Windows\CurrentVersion\Explorer\User Shell Folders
	call :addReg "%key%" "AppData" "REG_EXPAND_SZ" "%USERPROFILE%\AppData\Roaming"

	set key=HKU\.DEFAULT\Software\Microsoft\Windows\CurrentVersion\Explorer\User Shell Folders
	call :addReg "%key%" "AppData" "REG_EXPAND_SZ" "%USERPROFILE%\AppData\Roaming"

	reg add "HKLM\SYSTEM\CurrentControlSet\Control\BackupRestore\FilesNotToBackup" /f

	reg query "HKLM\SOFTWARE\Policies\Microsoft\Windows\CurrentVersion\Internet Settings" /v Security_HKLM_only | find /i "Security_HKLM_Only" | find "1"

	if %errorlevel% EQU 0 (
		set key=HKLM\Software\Microsoft\Windows\CurrentVersion\Internet Settings\ZoneMap\Domains
	) else (
		set key=HKCU\Software\Microsoft\Windows\CurrentVersion\Internet Settings\ZoneMap\Domains
	)

	call :addReg "%key%\microsoft.com\update" "http" "REG_DWORD" "2"
	call :addReg "%key%\microsoft.com\update" "https" "REG_DWORD" "2"
	call :addReg "%key%\microsoft.com\windowsupdate" "http" "REG_DWORD" "2"
	call :addReg "%key%\update.microsoft.com" "http" "REG_DWORD" "2"
	call :addReg "%key%\update.microsoft.com" "https" "REG_DWORD" "2"
	call :addReg "%key%\windowsupdate.com" "http" "REG_DWORD" "2"
	call :addReg "%key%\windowsupdate.microsoft.com" "http" "REG_DWORD" "2"
	call :addReg "%key%\download.microsoft.com" "http" "REG_DWORD" "2"
	call :addReg "%key%\windowsupdate.com" "http" "REG_DWORD" "2"
	call :addReg "%key%\windowsupdate.com" "https" "REG_DWORD" "2"
	call :addReg "%key%\windowsupdate.com\download" "http" "REG_DWORD" "2"
	call :addReg "%key%\windowsupdate.com\download" "https" "REG_DWORD" "2"
	call :addReg "%key%\download.windowsupdate.com" "http" "REG_DWORD" "2"
	call :addReg "%key%\download.windowsupdate.com" "https" "REG_DWORD" "2"
	call :addReg "%key%\windows.com\wustat" "http" "REG_DWORD" "2"
	call :addReg "%key%\wustat.windows.com" "http" "REG_DWORD" "2"
	call :addReg "%key%\microsoft.com\ntservicepack" "http" "REG_DWORD" "2"
	call :addReg "%key%\ntservicepack.microsoft.com" "http" "REG_DWORD" "2"
	call :addReg "%key%\microsoft.com\ws" "http" "REG_DWORD" "2"
	call :addReg "%key%\microsoft.com\ws" "https" "REG_DWORD" "2"
	call :addReg "%key%\ws.microsoft.com" "http" "REG_DWORD" "2"
	call :addReg "%key%\ws.microsoft.com" "https" "REG_DWORD" "2"

	:: ----- End process -----
	call :print L'operation s'est deroulee avec succes

	echo.Appuyez sur n'importe quelle touche pour continuer...
	pause>nul
goto :eof
:: /*************************************************************************************/


:: Reset Winsock setting.
:: void winsock();
:: /*************************************************************************************/
:winsock
	:: ----- Reset Winsock control -----
	call :print Reinitialisez le controle Winsock

	call :print Restauration des journaux de transaction
	fsutil resource setautoreset true C:\

	call :print Restauration de TPC/IP
	netsh int ip reset

	call :print Restauration de Winsock
	netsh winsock reset

	call :print Restauration des parametres de strategie par defaut
	netsh advfirewall reset

	call :print Restauration du cache DNS
	ipconfig /flushdns

	call :print Restauration du Proxy
	netsh winhttp reset proxy

	:: ----- End process -----
	call :print L'opeeration s'est deroulee avec succes

	echo.Appuyez sur n'importe quelle touche pour continuer...
	pause>nul
goto :eof
:: /*************************************************************************************/


:: Forcing group policy update.
:: void gpupdate();
:: /*************************************************************************************/
:gpupdate
	call :print Forcing group policy update.

	if %family% NEQ 5 (
		gpupdate /force
	) else (
		echo.Desole, cette option n'est pas disponible sur ce systeme d'exploitation
	)

	if %errorlevel% EQU 0 (
		echo.
		echo.L'operation s'est deroulee avec succes.
	) else (
		echo.
		echo.Une erreur s'est produite pendant le fonctionnement
	)

	echo.
	echo.Appuyez sur n'importe quelle touche pour continuer...
	pause>nul
goto :eof
:: /*************************************************************************************/


:: Search Updates.
:: void updates();
:: /*************************************************************************************/
:updates
	call :print Vous recherchez des mises à jour

	echo.Attendez...
	echo.

	wuauclt /resetauthorization /detectnow

	if %family% EQU 10 (
		start ms-settings:windowsupdate-action
	) else (
		if %family% NEQ 5 (
			start wuapp.exe
		) else (
			echo.
			echo.Une erreur imprevue s'est produite
			echo.
			echo.Appuyez sur n'importe quelle touche pour continuer...  
			pause>nul
		)
	)
goto :eof
:: /*************************************************************************************/


:: Run SetupDiag.
:: void setupDiag();
:: /*************************************************************************************/
:setupDiag
	for /f "tokens=1-5 delims=/., " %%a in ("%date%") do (
		set now=%%a%%b%%c%%d%time:~0,2%%time:~3,2%
	)

	if not exist "%USERPROFILE%\Desktop\Backup\Logs\%now%\" (
		mkdir "%USERPROFILE%\Desktop\Backup\Logs\%now%\"
	)

	call :print Execution de l'outil de diagnostic autonome SetupDiag
	
	if %family% EQU 10 (
		call "%~dp0SetupDiag.exe" /Output:"%USERPROFILE%\Desktop\Backup\Logs\%now%\WindowsUpdate.log" /Format:log
	) else (
		echo.Desole, cette option n'est pas disponible sur ce systeme d'exploitation
	)

	echo.
	echo.Appuyez sur n'importe quelle touche pour continuer...
	pause>nul
goto :eof
:: /*************************************************************************************/


:: Explore other local solutions.
:: void local();
:: /*************************************************************************************/
:local
	call :print Recherche de solutions sur ce PC

	if %family% NEQ 5 (
		start control.exe /name Microsoft.Troubleshooting
	) else (
		echo.Desole, cette option n'est pas disponible sur ce systeme d'exploitation
		echo.
		echo.Appuyez sur n'importe quelle touche pour continuer...
		pause>nul
	)
goto :eof
:: /*************************************************************************************/


:: Explore other online solutions.
:: void online();
:: /*************************************************************************************/
:online
	call :print Recherche de solutions en ligne

	start https://support.microsoft.com/en-us/gp/windows-update-issues/
goto :eof
:: /*************************************************************************************/


:: Reboot the system.
:: void restart();
:: /*************************************************************************************/
:restart
	call :print Redemarrer votre PC

	if %family% NEQ 5 (
		echo.    The system reboot in 60 seconds.
		echo.    Please save all open documents.

		start shutdown.exe /r /t 60 /c "The system reboot in 60 seconds. Please save all open documents."
	) else (
		echo.Desole, cette option n'est pas disponible sur ce systeme d'exploitation
	)

	echo.
	echo.Appuyez sur n'importe quelle touche pour continuer...
	pause>nul
goto :eof
:: /*************************************************************************************/


:: Open help file.
:: void help();
:: /*************************************************************************************/
:help
	start http://docs.wureset.com/
goto :eof
:: /*************************************************************************************/


:: diagnostic tools menu.
:: void diagnostic();
:: /*************************************************************************************/
:diagnostic
	call :print Telechargez et executez des diagnostics pour votre systeme

	echo.    1. Windows Update on Windows 7, Windows 8 and Windows 8.1.
	echo.    2. Windows Update on Windows 10.
	echo.    3. Apps on Windows 8.1.
	echo.    4. Apps on Windows 10.
	echo.
	echo.                                                        0. Back.
	echo.

	set /p option=Select an option: 

	if %option% EQU 0 (
		goto menu
	) else if %option% EQU 1 (
		start http://go.microsoft.com/?linkid=9830262
	) else if %option% EQU 2 (
		start http://aka.ms/diag_wu
	) else if %option% EQU 3 (
		start http://go.microsoft.com/fwlink/p/?LinkId=268423
	) else if %option% EQU 4 (
		start http://aka.ms/diag_apps10
	) else (
		echo.
		echo.Option invalide
		echo.
		echo.Appuyez sur n'importe quelle touche pour continuer...
		pause>nul
	)
 
	goto diagnostic
goto :eof
:: /*************************************************************************************/


:: End tool.
:: void close();
:: /*************************************************************************************/
:close
	exit
goto :eof
:: /*************************************************************************************/

